/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $
 *
 * $Id:$
 */
#ifndef DOT1DBASEPORTTABLE_H
#define DOT1DBASEPORTTABLE_H

#ifdef __cplusplus
extern "C" {
#endif


/** @addtogroup misc misc: Miscellaneous routines
 *
 * @{
 */
#include <net-snmp/library/asn1.h>

/* other required module components */
    /* *INDENT-OFF*  */
config_add_mib(BRIDGE-MIB)
config_require(BRIDGE-MIB/dot1dBasePortTable/dot1dBasePortTable_interface)
config_require(BRIDGE-MIB/dot1dBasePortTable/dot1dBasePortTable_data_access)
config_require(BRIDGE-MIB/dot1dBasePortTable/dot1dBasePortTable_data_get)
config_require(BRIDGE-MIB/dot1dBasePortTable/dot1dBasePortTable_data_set)
    /* *INDENT-ON*  */

/* OID and column number definitions for dot1dBasePortTable */
#include "dot1dBasePortTable_oids.h"

/* enum definions */
#include "dot1dBasePortTable_enums.h"

/* *********************************************************************
 * function declarations
 */
void init_dot1dBasePortTable(void);
void shutdown_dot1dBasePortTable(void);

/* *********************************************************************
 * Table declarations
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table dot1dBasePortTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * BRIDGE-MIB::dot1dBasePortTable is subid 4 of dot1dBase.
 * Its status is Current.
 * OID: .1.3.6.1.2.1.17.1.4, length: 9
*/
/* *********************************************************************
 * When you register your mib, you get to provide a generic
 * pointer that will be passed back to you for most of the
 * functions calls.
 *
 * TODO:100:r: Review all context structures
 */
    /*
     * TODO:101:o: |-> Review dot1dBasePortTable registration context.
     */
typedef netsnmp_data_list dot1dBasePortTable_registration;

/**********************************************************************/
/*
 * TODO:110:r: |-> Review dot1dBasePortTable data context structure.
 * This structure is used to represent the data for dot1dBasePortTable.
 */
/*
 * This structure contains storage for all the columns defined in the
 * dot1dBasePortTable.
 */
typedef struct dot1dBasePortTable_data_s {
    
        /*
         * dot1dBasePortIfIndex(2)/InterfaceIndex/ASN_INTEGER/long(long)//l/A/w/e/R/d/H
         */
   long   dot1dBasePortIfIndex;
    
        /*
         * dot1dBasePortCircuit(3)/OBJECTID/ASN_OBJECT_ID/oid(oid)//L/A/w/e/r/d/h
         */
   oid   dot1dBasePortCircuit[128];
size_t      dot1dBasePortCircuit_len; /* # of oid elements, not bytes */
} dot1dBasePortTable_data;


/*
 * TODO:120:r: |-> Review dot1dBasePortTable mib index.
 * This structure is used to represent the index for dot1dBasePortTable.
 */
typedef struct dot1dBasePortTable_mib_index_s {

        /*
         * dot1dBasePort(1)/INTEGER32/ASN_INTEGER/long(long)//l/A/w/e/R/d/h
         */
   long   dot1dBasePort;


} dot1dBasePortTable_mib_index;

    /*
     * TODO:121:r: |   |-> Review dot1dBasePortTable max index length.
     * If you KNOW that your indexes will never exceed a certain
     * length, update this macro to that length.
*/
#define MAX_dot1dBasePortTable_IDX_LEN     1


/* *********************************************************************
 * TODO:130:o: |-> Review dot1dBasePortTable Row request (rowreq) context.
 * When your functions are called, you will be passed a
 * dot1dBasePortTable_rowreq_ctx pointer.
 */
typedef struct dot1dBasePortTable_rowreq_ctx_s {

    /** this must be first for container compare to work */
    netsnmp_index        oid_idx;
    oid                  oid_tmp[MAX_dot1dBasePortTable_IDX_LEN];
    
    dot1dBasePortTable_mib_index        tbl_idx;
    
    dot1dBasePortTable_data              data;

    /*
     * flags per row. Currently, the first (lower) 8 bits are reserved
     * for the user. See mfd.h for other flags.
     */
    u_int                       rowreq_flags;

    /*
     * TODO:131:o: |   |-> Add useful data to dot1dBasePortTable rowreq context.
     */
    
    /*
     * storage for future expansion
     */
    netsnmp_data_list             *dot1dBasePortTable_data_list;

} dot1dBasePortTable_rowreq_ctx;

typedef struct dot1dBasePortTable_ref_rowreq_ctx_s {
    dot1dBasePortTable_rowreq_ctx *rowreq_ctx;
} dot1dBasePortTable_ref_rowreq_ctx;

/* *********************************************************************
 * function prototypes
 */
    int dot1dBasePortTable_pre_request(dot1dBasePortTable_registration * user_context);
    int dot1dBasePortTable_post_request(dot1dBasePortTable_registration * user_context,
        int rc);

    int dot1dBasePortTable_rowreq_ctx_init(dot1dBasePortTable_rowreq_ctx *rowreq_ctx,
                                   void *user_init_ctx);
    void dot1dBasePortTable_rowreq_ctx_cleanup(dot1dBasePortTable_rowreq_ctx *rowreq_ctx);


    dot1dBasePortTable_rowreq_ctx *
                  dot1dBasePortTable_row_find_by_mib_index(dot1dBasePortTable_mib_index *mib_idx);

extern const oid dot1dBasePortTable_oid[];
extern const int dot1dBasePortTable_oid_size;


#include "dot1dBasePortTable_interface.h"
#include "dot1dBasePortTable_data_access.h"
#include "dot1dBasePortTable_data_get.h"
#include "dot1dBasePortTable_data_set.h"

/*
 * DUMMY markers, ignore
 *
 * TODO:099:x: *************************************************************
 * TODO:199:x: *************************************************************
 * TODO:299:x: *************************************************************
 * TODO:399:x: *************************************************************
 * TODO:499:x: *************************************************************
 */

#ifdef __cplusplus
}
#endif

#endif /* DOT1DBASEPORTTABLE_H */
/** @} */
